clear;

plot_length = false;
plot_sequence = true;



myDir = 'C:\Users\eivindjk\Documents\Master\Hare\1110806\CL_10160 NY\2017-11-02-15-50';
tl4Files = dir(fullfile(myDir,'*SingleHole.tl4'));
if (~isempty(tl4Files))
    baseName = tl4Files(1).name;
    fullFileName = fullfile(myDir, baseName);
    fileDir = dir(fullFileName);
    if fileDir.bytes == 0

    else
        holes = readTl4(fullFileName);
    end
    for i = 2:length(tl4Files)
        baseName = tl4Files(i).name;
        fullFileName = fullfile(myDir, baseName);
        fileDir = dir(fullFileName);
        if fileDir.bytes == 0

        else
            holes(end+1) = readTl4(fullFileName);
        end
    end
end
boom1First = true;
boom2First = true;
boom3First = true;
for i = 1:length(holes)
    switch holes(i).Boom
        case 1
            if boom1First
                boom1(1) = holes(i);
                boom1First = false;
            else
                boom1(end+1) = holes(i);
            end
        case 2
            if boom2First
                boom2(1) = holes(i);
                boom2First = false;
            else
                boom2(end+1) = holes(i);
            end
        case 3
            if boom3First
                boom3(1) = holes(i);
                boom3First = false;
            else
                boom3(end+1) = holes(i);
            end
    end
end



fig1 = figure('Name',strcat('Section: ',myDir),'units','normalized','outerposition',[0 0 1 1]);
grid on
%Plot size
maxY=-100;
minY=100;
maxZ=-100;
minZ=100;
for i = 1:length(holes)
    if holes(i).CoordStart.Y > maxY
        maxY = holes(i).CoordStart.Y;
    end
    if holes(i).CoordStart.Y < minY
        minY = holes(i).CoordStart.Y;
    end
    if holes(i).CoordStart.Z > maxZ
        maxZ = holes(i).CoordStart.Z;
    end
    if holes(i).CoordStart.Z < minZ
        minZ = holes(i).CoordStart.Z;
    end
end

axis([minY-1 maxY+1 minZ-1 maxZ+1])


first_start = holes(1).StartTime;
clock = text(0,0,'0');

prev1 = boom1(1);
prev2 = boom2(1);
prev3 = boom3(1);
for i = 1:length(holes)
    hold all
    if holes(i).HoleType ~= 4 && holes(i).HoleType ~= 5 && holes(i).HoleType ~= 6
        switch holes(i).Boom
           case 1
               scatter(holes(i).CoordStart.Y,holes(i).CoordStart.Z,32,'red')
           case 2
               scatter(holes(i).CoordStart.Y,holes(i).CoordStart.Z,32,'blue')
           case 3
               scatter(holes(i).CoordStart.Y,holes(i).CoordStart.Z,32,'green')
        end
        switch holes(i).Boom
           case 1
               q = quiver(prev1.CoordStart.Y,prev1.CoordStart.Z,holes(i).CoordStart.Y-prev1.CoordStart.Y,holes(i).CoordStart.Z-prev1.CoordStart.Z);
               q.Color = 'red';
               prev1 = holes(i);
           case 2
               q = quiver(prev2.CoordStart.Y,prev2.CoordStart.Z,holes(i).CoordStart.Y-prev2.CoordStart.Y,holes(i).CoordStart.Z-prev2.CoordStart.Z);
               q.Color = 'blue';
               prev2 = holes(i);
           case 3
               q = quiver(prev3.CoordStart.Y,prev3.CoordStart.Z,holes(i).CoordStart.Y-prev3.CoordStart.Y,holes(i).CoordStart.Z-prev3.CoordStart.Z);
               q.Color = 'green';
               prev3 = holes(i);
        end
        hold off
        drawnow
        start = 3600*24*datenum(holes(i).StartTime - first_start);
        if i~=length(holes)
            nextStart = 3600*24*datenum(holes(i+1).StartTime - first_start);
        else
            nextStart = start;
        end
        pauseDuration = nextStart-start;
        
        delete(clock);
        clock = text(-6.5,9,['Seconds: ' int2str(start)],'FontSize',14);
        
        
        pause(pauseDuration/2000);
    end
end

