function [left, right, center] = allocateHoles(drillPlan)
    [x,y,typeOfHole] = getDrillPlan(drillPlan);
    xy = [x,y];
    for i=1:length(x)
        if typeOfHole(i) == 'Reference'
            if i==length(x)
                xy = [xy(1:i-1,:)];
            elseif i==1
                xy = [xy(2:end,:)];
            else
                xy = [xy(1:i-1,:);xy(i+1:end,:)];
            end
        end
    end
    odd = false;
    divThree = false;
    if mod(length(xy),2) == 1
        odd = true;
    end
    if mod(length(xy),3) == 0
        divThree = true;
    end

    lineX = 0;

    xy = sortrows(xy,1);
    if odd
        mid = ceil(length(xy)/2);
        left = xy(1:mid,:);
        right = xy(mid+1:end,:);
        lineX = xy(mid,1);
    else
        mid = length(xy)/2;
        left = xy(1:mid,:);
        right = xy(mid+1:end,:);
        lineX = (xy(mid,1) + xy(mid,1))/2;
    end

    centerPoint = [lineX 0];


    i = findClosest(left,centerPoint);
    center = left(i,:);
    left = removeFromArray(left,i);

    finished = false;

    while ~finished
        if divThree
            if length(left) == length(right) && length(left) == length(center)
                finished = true;
            else
                if length(left) >= length(right)
                    i = findClosest(left,centerPoint);
                    center(end+1,:) = left(i,:);
                    left = removeFromArray(left,i);
                else
                    i = findClosest(right,centerPoint);
                    center(end+1,:) = right(i,:);
                    right = removeFromArray(right,i);
                end
            end
        else
            l = length(left);
            r = length(right);
            c = length(center);
            if (l<=r+1 && l>=r-1) && (l<=c+1 && l>=c-1) && (c<=r+c && c>=r-c)
                finished = true;
            else
                if length(left) >= length(right)
                    i = findClosest(left,centerPoint);
                    center(end+1,:) = left(i,:);
                    left = removeFromArray(left,i);
                else
                    i = findClosest(right,centerPoint);
                    center(end+1,:) = right(i,:);
                    right = removeFromArray(right,i);
                end
            end
        end
    end
end
