clear;
score = {};
logDir = 'Pel13960-14410';
logs = dir(logDir);
logs = logs(3:end);

for i=1:size(logs,1)
    filename = fullfile(logDir, logs(i).name);
    [tunnelLine, pel, drillDir, nHoles, xStart, yStart, zStart, xEnd, yEnd, zEnd, holeType, boom, holeNoPlan, startTime, endTime, error] = readTl4CompleteWithError(filename);
    if ~error
        holesArray = [holeType boom xStart yStart zStart xEnd yEnd zEnd startTime endTime];
        [sequenceDuration, totalDownTime, boom1DownTime, boom2DownTime, boom3DownTime, endSync, distance] = calculateScore(holesArray);

        holesArray =sortrows(holesArray, 9);
        if size(holesArray,1) > 1
            sequenceID = logs(i).name;

            [sequenceDuration, totalDownTime, boom1DownTime, boom2DownTime, boom3DownTime, endSync, distance] = sequenceScore(holesArray);
            score = [score; {sequenceID, sequenceDuration, totalDownTime, boom1DownTime, boom2DownTime, boom3DownTime, endSync, distance, size(holesArray,1)}];
        end
    end
end
%%
figure
histfit(cell2mat(score(:,3))./cell2mat(score(:,2)),50,'kernel')
xlabel('Time not drilling normalized to total drill time');
ylabel('Occurrence');
legend('Data','Probability distribution');
a=cellstr(num2str(get(gca,'xtick')'*100));
pct = char(ones(size(a,1),1)*'%');
new_xticks = [char(a),pct];
set(gca,'xticklabel',new_xticks);
%%
figure
histfit(cell2mat(score(:,7))./cell2mat(score(:,2)),50,'kernel')
xlabel('Time not drilling normalized to total drill time');
ylabel('Occurrence');
legend('Data','Probability distribution');
a=cellstr(num2str(get(gca,'xtick')'*100));
pct = char(ones(size(a,1),1)*'%');
new_xticks = [char(a),pct];
set(gca,'xticklabel',new_xticks);
%%
figure
histfit(cell2mat(score(:,7))./cell2mat(score(:,2)),50,'kernel')
xlabel('Time not drilling normalized to total drill time');
ylabel('Occurrence');
legend('Data','Probability distribution');
a=cellstr(num2str(get(gca,'xtick')'*100));
pct = char(ones(size(a,1),1)*'%');
new_xticks = [char(a),pct];
set(gca,'xticklabel',new_xticks)
%%
figure
histfit(cell2mat(score(:,8))./cell2mat(score(:,9)),50,'kernel')
xlabel('Distance moved for each hole');
ylabel('Occurrence');
legend('Data','Probability distribution');
xlim([0 inf]);
hold on
m = mean(cell2mat(score(:,8))./cell2mat(score(:,9)));
line([m m], [0 10],'Color','r');