clear;
score = {};

topDir = 'C:\Users\eivindjk\Documents\Master\Hare\1110806\CL_10160 NY';
topDirFiles = dir(topDir);

dirFlags = [topDirFiles.isdir];
folders = topDirFiles(dirFlags);
firstDist = true;
for j = 3:size(folders,1)
    baseFolderName = folders(j).name;
    myDir = fullfile(topDir, baseFolderName);
    %myDir = 'C:\Users\eivindjk\Documents\Master\Hare\1110806\CL_10160 NY\2017-10-23-07-53';
    tl4Files = dir(fullfile(myDir,'*SingleHole.tl4'));
    if (~isempty(tl4Files))
        baseName = tl4Files(1).name;
        fullFileName = fullfile(myDir, baseName);
        fileDir = dir(fullFileName);
        if fileDir.bytes == 0
            
        else
            holes = readTl4(fullFileName);
        end
        for i = 2:length(tl4Files)
            baseName = tl4Files(i).name;
            fullFileName = fullfile(myDir, baseName);
            fileDir = dir(fullFileName);
            if fileDir.bytes == 0
                
            else
                holes(end+1) = readTl4(fullFileName);
            end
        end
    else
        continue
    end
    
    breakInner = false;
    for i=1:size(holes,1)
        if holes(i).StartTime.Year < 1900 || holes(i).EndTime.Year < 1900
            display(strcat('Error in Start/End time for hole: ', tl4Files(i).name))
            breakInner = true;
            break;
        end
    end
    if breakInner
        continue
    end
    %Convert data to array sortet by start time
    sequenceStart = holes(1).StartTime;
    for i=2:length(holes)
       if holes(i).StartTime < sequenceStart
           sequenceStart = holes(i).StartTime;
       end
    end
    
    holesArray = [];
    holesArray(1,:) = [holes(1).HoleType holes(1).Boom holes(1).CoordStart.X holes(1).CoordStart.Y holes(1).CoordStart.Z holes(1).CoordEnd.X holes(1).CoordEnd.Y holes(1).CoordEnd.Z round(3600*24*datenum(holes(1).StartTime-sequenceStart)) round(3600*24*datenum(holes(1).EndTime-sequenceStart))];
    for i=2:length(holes)
        holesArray(end+1,:) = [holes(i).HoleType holes(i).Boom holes(i).CoordStart.X holes(i).CoordStart.Y holes(i).CoordStart.Z holes(i).CoordEnd.X holes(i).CoordEnd.Y holes(i).CoordEnd.Z round(3600*24*datenum(holes(i).StartTime-sequenceStart)) round(3600*24*datenum(holes(i).EndTime-sequenceStart))];
    end
    holesArray =sortrows(holesArray, 9);
    
    if size(holesArray,1) > 1
        splitPath = strsplit(myDir,'\');
        sequenceID = char(strcat(splitPath(end-1),'\',splitPath(end)));
        
        [sequenceDuration, totalDownTime, boom1DownTime, boom2DownTime, boom3DownTime, endSync, distance] = sequenceScore(holesArray);
        score = [score; {sequenceID, sequenceDuration, totalDownTime, boom1DownTime, boom2DownTime, boom3DownTime, endSync}];
        if firstDist
            allDistances = distance';
            firstDist = false;
        else
            allDistances = [allDistances; distance'];
        end
    end
end
score = sortrows(score,2);
%% Total
f1=figure;
histfit(cell2mat(score(:,3))./(3*cell2mat(score(:,2))),50,'kernel');
legend('Data','Probability distribution');
ylim([0 30]);
a=cellstr(num2str(get(gca,'xtick')'*100));
pct = char(ones(size(a,1),1)*'%');
new_xticks = [char(a),pct];
set(gca,'xticklabel',new_xticks);
set(f1,'Units','Pixels');
set(f1, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
title('Total transition time normelized to total drill time','FontSize',96);
xlabel('Total transition time/(nBooms*Total drill time)','FontSize',48);
ylabel('Occurrence','FontSize',48);
set(gca,'FontSize',32)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesTotal.png'));
saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesTotal.fig'));
saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesTotal.eps'),'epsc');
a_tot = mean(cell2mat(score(:,3))./(3*cell2mat(score(:,2))));
%% Boom1
f2=figure;
histfit(cell2mat(score(:,4))./cell2mat(score(:,2)),50,'kernel');
legend('Data','Probability distribution');
ylim([0 30]);
a=cellstr(num2str(get(gca,'xtick')'*100));
pct = char(ones(size(a,1),1)*'%');
new_xticks = [char(a),pct];
set(gca,'xticklabel',new_xticks);
set(f2,'Units','Pixels');
set(f2, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
title('Transition time on boom 1 normelized to total drill time','FontSize',96);
xlabel('Total transition time/Total drill time','FontSize',48);
ylabel('Occurrence','FontSize',48);
set(gca,'FontSize',32)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

saveas(f2,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesBoom1.png'));
saveas(f2,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesBoom1.fig'));
saveas(f2,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesBoom1.eps'),'epsc');
a1=mean(cell2mat(score(:,4))./cell2mat(score(:,2)));
%% Boom2
f3=figure;
histfit(cell2mat(score(:,5))./cell2mat(score(:,2)),50,'kernel');
legend('Data','Probability distribution');
ylim([0 30]);
a=cellstr(num2str(get(gca,'xtick')'*100));
pct = char(ones(size(a,1),1)*'%');
new_xticks = [char(a),pct];
set(gca,'xticklabel',new_xticks);
set(f3,'Units','Pixels');
set(f3, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
title('Transition time on boom 2 normelized to total drill time','FontSize',96);
xlabel('Total transition time/Total drill time','FontSize',48);
ylabel('Occurrence','FontSize',48);
set(gca,'FontSize',32)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

saveas(f3,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesBoom2.png'));
saveas(f3,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesBoom2.fig'));
saveas(f3,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesBoom2.eps'),'epsc');
a2=mean(cell2mat(score(:,5))./cell2mat(score(:,2)));
%% Boom3
f4=figure;
histfit(cell2mat(score(:,6))./cell2mat(score(:,2)),50,'kernel');
legend('Data','Probability distribution');
ylim([0 30]);
a=cellstr(num2str(get(gca,'xtick')'*100));
pct = char(ones(size(a,1),1)*'%');
new_xticks = [char(a),pct];
set(gca,'xticklabel',new_xticks);
set(f4,'Units','Pixels');
set(f4, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
title('Transition time on boom 3 normelized to total drill time','FontSize',96);
xlabel('Total transition time/Total drill time','FontSize',48);
ylabel('Occurrence','FontSize',48);
set(gca,'FontSize',32)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

saveas(f4,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesBoom3.png'));
saveas(f4,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesBoom3.fig'));
saveas(f4,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','nonDrillTimesBoom3.eps'),'epsc');
a3=mean(cell2mat(score(:,6))./cell2mat(score(:,2)));

%% End sync
f5=figure;
toPlot = cell2mat(score(:,7));
indices = find(toPlot>10000);
toPlot(indices) = [];
histfit(toPlot,50,'kernel');
legend('Data','Probability distribution');
set(f5,'Units','Pixels');
set(f5, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
title('Boom finished synchronization','FontSize',72);
xlabel('Time [s]','FontSize',32);
ylabel('Occurrence','FontSize',32);
set(gca,'FontSize',21);
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

saveas(f5,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','endSync.png'));
saveas(f5,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','endSync.fig'));
saveas(f5,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','endSync.eps'),'epsc');
aEndSync=mean(toPlot);

%% Distance
f6=figure;
allDistances=allDistances(allDistances~=0,:);
allDistances=allDistances(allDistances<10,:);
histfit(allDistances,50,'kernel');
legend('Data','Probability distribution');
set(f6,'Units','Pixels');
set(f6, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
title('Distance moved for each hole','FontSize',72);
xlabel('Distance [m]','FontSize',32);
ylabel('Occurrence','FontSize',32);
set(gca,'FontSize',21)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

saveas(f6,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','distance.png'));
saveas(f6,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','distance.fig'));
saveas(f6,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','distance.eps'),'epsc');
aDist = mean(allDistances);
varDist = var(allDistances);