clear;
planDir = 'C:\Users\eivindjk\Documents\Bever Team\Favorites\Drillplans';
plans = dir(planDir);
plans = plans(3:end);

for j=1:size(plans,1)
    filename = fullfile(planDir, plans(j).name);
    [left,right,center] = allocateHoles(filename);
    f1 = figure;
    hold on
    p1 = scatter(left(:,1),left(:,2),'r');
    p2 = scatter(center(:,1),center(:,2),'g');
    p3 = scatter(right(:,1),right(:,2),'b');
    hold off
    set(f1,'Units','Pixels');
    set(f1, 'OuterPosition', [0, 0, 1500, 1200]);
    grid on
    title('Allocated holes','FontSize',48);
    xlabel('Distance [m]','FontSize',24);
    ylabel('Distance [m]','FontSize',24);
    set(gca,'FontSize',16)
    ax = gca;
    outerpos = ax.OuterPosition;
    ti = ax.TightInset; 
    left_m = outerpos(1) + ti(1);
    bottom = outerpos(2) + ti(2);
    ax_width = outerpos(3) - ti(1) - ti(3);
    ax_height = outerpos(4) - ti(2) - ti(4);
    ax.Position = [left_m bottom ax_width ax_height];
    legend([p1 p2 p3],{'Boom 1','Boom 2','Boom 3'});
    saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','Allocated_holes',int2str(j),'.png'));
    saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','Allocated_holes',int2str(j),'.fig'));
    saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','Allocated_holes',int2str(j),'.eps'),'epsc');
    close(f1);
    f = figure;
    hold on
    p1 = scatter(left(:,1),left(:,2),'r');
    p2 = scatter(center(:,1),center(:,2),'g');
    p3 = scatter(right(:,1),right(:,2),'b');

    distance = 0;

    [start, stop] = getShortestPath(left);
    for i=1:length(start)
        q = quiver(start(i,1),start(i,2),stop(i,1)-start(i,1),stop(i,2)-start(i,2),'AutoScale','off','MaxHeadSize',1);
        q.Color = [1 0.5 0.5];
    end
    distance = distance + calculateDistance(start, stop);

    [start, stop] = getShortestPath(center);
    for i=1:length(start)
        q = quiver(start(i,1),start(i,2),stop(i,1)-start(i,1),stop(i,2)-start(i,2),'AutoScale','off','MaxHeadSize',1);
        q.Color = [0.5 1 0.5];
    end
    distance = distance + calculateDistance(start, stop);

    [start, stop] = getShortestPath(right);
    for i=1:length(start)
        q = quiver(start(i,1),start(i,2),stop(i,1)-start(i,1),stop(i,2)-start(i,2),'AutoScale','off','MaxHeadSize',1);
        q.Color = [0.5 0.5 1];
    end
    distance = distance + calculateDistance(start, stop);
    distanceNormalized = distance/(size(left,1)+size(center,1)+size(right,1));

    set(f,'Units','Pixels');
    set(f, 'OuterPosition', [0, 0, 1500, 1200]);
    grid on
    title('Optimal drill sequence','FontSize',48);
    xlabel('Distance [m]','FontSize',24);
    ylabel('Distance [m]','FontSize',24);
    set(gca,'FontSize',16)
    ax = gca;
    outerpos = ax.OuterPosition;
    ti = ax.TightInset; 
    left_m = outerpos(1) + ti(1);
    bottom = outerpos(2) + ti(2);
    ax_width = outerpos(3) - ti(1) - ti(3);
    ax_height = outerpos(4) - ti(2) - ti(4);
    ax.Position = [left_m bottom ax_width ax_height];
    legend([p1 p2 p3],{'Boom 1','Boom 2','Boom 3'});
    
    saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','Optimal_drill_sequence',int2str(j),'.png'));
    saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','Optimal_drill_sequence',int2str(j),'.fig'));
    saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','Optimal_drill_sequence',int2str(j),'.eps'),'epsc');
    close(f);
end