clear;

logDir = 'Pel13960-14410';
logs = dir(logDir);
logs = logs(3:end);


x = [];
y = x;
z = x;
b = x;
t = x;

for i=1:size(logs,1)
    filename = fullfile(logDir, logs(i).name);
    [tunnelLine, pel, drillDir, nHoles, xStart, yStart, zStart, xEnd, yEnd, zEnd, holeType, boom, holeNoPlan, startTime, endTime] = readTl4Complete(filename);
    x = [x',xStart']';
    y = [y',yStart']';
    z = [z',zStart']';
    b = [b',boom']';
    t = [t',holeType']';
end

%%
f = figure;
hold on
for i=1:length(x)
    if t(i) ~= 4 && t(i) ~= 5 && t(i) ~= 6
        switch b(i)
            case 1
                p1 = scatter(-y(i),z(i),'r');
            case 2
                p2 = scatter(-y(i),z(i),'g');
            case 3
                p3 = scatter(-y(i),z(i),'b');
        end
    end
end

drawnow
set(f,'Units','Pixels');
set(f, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
legend([p1 p2 p3],{'Boom 1','Boom 2','Boom 3'});
title('Holes from Pel 13960-14410','FontSize',48);
xlabel('Distance [m]','FontSize',24);
ylabel('Distance [m]','FontSize',24);
set(gca,'FontSize',16)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

%%
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','allInSamePel13960-14410.png'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','allInSamePel13960-14410.fig'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','allInSamePel13960-14410.eps'),'epsc');
