drillPlan = 'C:\Users\eivindjk\Documents\Bever Team\Favorites\Drillplans\STIGENDE Normalprofil 13960-14410 med 169 ladet hull.xml';
boltPlan = 'C:\Users\eivindjk\Documents\Bever Team\Favorites\Drillplans\Bolteplan Klasse C pel 13960-14410 Stigende.xml';

[x,y,z,typeOfHole] = getDrillPlan3D(drillPlan);
[x_b,y_b,z_b,typeOfHole_b] = getDrillPlan3D(boltPlan);

x=[x;x_b;x_b];
y=[y;y_b;y_b];
z=[z;z_b;z_b];
typeOfHole=[typeOfHole;typeOfHole_b;typeOfHole_b];

y(end-2*length(y_b)+1:end-length(y_b)) = -2;
y(end-length(y_b)+1:end) = -4;

f = figure;
view([-1.5,1,1])
set(f,'Units','Pixels');
set(f, 'OuterPosition', [0, 0, 1500, 1200]);
hold on
for i=1:length(x)
    switch typeOfHole(i)
        case 'BoltHole'
            p1 = scatter3(x(i),y(i),z(i),'black');
        case 'Bottom'
            p2 = scatter3(x(i),y(i),z(i),'c');
        case 'EasersHole'
            p3 = scatter3(x(i),y(i),z(i),'b');
        case 'Contour'
            p4= scatter3(x(i),y(i),z(i),'r');
        case 'SecondContour'
            p5 = scatter3(x(i),y(i),z(i),'g');
        case 'CutHole'
            p6 = scatter3(x(i),y(i),z(i),'m');
        case 'Reference'
            p7 = scatter3(x(i),y(i),z(i),[],[1 0.5 0]);
        case 'ReamingHole'
            p8 = scatter3(x(i),y(i),z(i),48,[0.5 0.5 0.5]);
        otherwise
            p9 = scatter3(x(i),y(i),z(i),'y');
    end
end
grid on
legend([p1 p2 p3 p4 p5 p6 p7 p8],{'BoltHole','Bottom','EasersHole','Contour','SecondContour','CutHole','Reference','ReamingHole'},'Location','northeast','FontSize',16);
title('Drill and bolt plan with hole types','FontSize',48);
xlabel('Distance [m]','FontSize',24);
ylabel('Distance [m]','FontSize',24);
set(gca,'FontSize',16)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];
daspect([1 0.5 1]);

saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Drill_and_bolt_plan_hole_types.png'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Drill_and_bolt_plan_hole_types.fig'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Drill_and_bolt_plan_hole_types.eps'),'epsc');