clear;

plot_length = false;
plot_sequence = true;

topDir = 'C:\Users\eivindjk\Documents\Master\Hare\1110695\CL_10160 NY';
topDirFiles = dir(topDir);

dirFlags = [topDirFiles.isdir];
folders = topDirFiles(dirFlags);

for j = 1:length(folders)
    baseFolderName = folders(j).name;
    myDir = fullfile(topDir, baseFolderName);
    %myDir = 'C:\Users\eivindjk\Documents\Master\Hare\1110806\CL_10160 NY\2017-10-23-07-53';
    tl4Files = dir(fullfile(myDir,'*SingleHole.tl4'));
    if (isempty(tl4Files))
        
    else
        baseName = tl4Files(1).name;
        fullFileName = fullfile(myDir, baseName);
        fileDir = dir(fullFileName);
        if fileDir.bytes == 0
            
        else
            holes = readTl4(fullFileName);
        end
        for i = 2:length(tl4Files)
            baseName = tl4Files(i).name;
            fullFileName = fullfile(myDir, baseName);
            fileDir = dir(fullFileName);
            if fileDir.bytes == 0
                
            else
                holes(end+1) = readTl4(fullFileName);
            end
        end
        %% Plot section
        fig1 = figure('Name',strcat('Section: ',baseFolderName),'units','normalized','outerposition',[0 0 1 1]);
        view([1,1,1])
        grid on

        prev1 = holes(1);
        prev2 = holes(1);
        prev3 = holes(1);
        boom1 = true;
        boom2 = true;
        boom3 = true;

        for i = 1:length(holes)
           hold all
           switch holes(i).Boom
               case 1
                   scatter3(holes(i).CoordStart.X,holes(i).CoordStart.Y,holes(i).CoordStart.Z,32,'red')
               case 2
                   scatter3(holes(i).CoordStart.X,holes(i).CoordStart.Y,holes(i).CoordStart.Z,32,'blue')
               case 3
                   scatter3(holes(i).CoordStart.X,holes(i).CoordStart.Y,holes(i).CoordStart.Z,32,'green')
           end
           dx = 0.1;
           dy = 0.1;
           dz = 0.1;
           text(holes(i).CoordStart.X+dx,holes(i).CoordStart.Y+dy,holes(i).CoordStart.Z+dz,int2str(i));
           if plot_sequence
               switch holes(i).Boom
                   case 1
                       if boom1
                           prev1 = holes(i);
                           boom1 = false;
                       else
                           q = quiver3(prev1.CoordStart.X,prev1.CoordStart.Y,prev1.CoordStart.Z,holes(i).CoordStart.X-prev1.CoordStart.X,holes(i).CoordStart.Y-prev1.CoordStart.Y,holes(i).CoordStart.Z-prev1.CoordStart.Z);
                           q.Color = 'red';
                           prev1 = holes(i);
                       end
                   case 2
                       if boom2
                           prev2 = holes(i);
                           boom2 = false;
                       else
                           q = quiver3(prev2.CoordStart.X,prev2.CoordStart.Y,prev2.CoordStart.Z,holes(i).CoordStart.X-prev2.CoordStart.X,holes(i).CoordStart.Y-prev2.CoordStart.Y,holes(i).CoordStart.Z-prev2.CoordStart.Z);
                           q.Color = 'blue';
                           prev2 = holes(i);
                       end
                   case 3
                       if boom3
                           prev3 = holes(i);
                           boom3 = false;
                       else
                           q = quiver3(prev3.CoordStart.X,prev3.CoordStart.Y,prev3.CoordStart.Z,holes(i).CoordStart.X-prev3.CoordStart.X,holes(i).CoordStart.Y-prev3.CoordStart.Y,holes(i).CoordStart.Z-prev3.CoordStart.Z);
                           q.Color = 'green';
                           prev3 = holes(i);
                       end
                   otherwise
               end
           end
           if plot_length
               q = quiver3(holes(i).CoordStart.X,holes(i).CoordStart.Y,holes(i).CoordStart.Z,holes(i).CoordEnd.X-holes(i).CoordStart.X,holes(i).CoordEnd.Y-holes(i).CoordStart.Y,holes(i).CoordEnd.Z-holes(i).CoordStart.Z);
               q.Color = 'black';
           end
           hold off
           %legend('Boom 1','Boom 2', 'Boom 3');


        end
        drawnow
        saveas(fig1,strcat('C:\Users\eivindjk\Documents\Master\Plots\Section_',baseFolderName),'fig');
        close(fig1);
        % hold all
        % quiver3(0,0,0,holes(1).TargetRot(1,1),holes(1).TargetRot(2,1),holes(1).TargetRot(3,1),'r')
        % quiver3(0,0,0,holes(1).TargetRot(1,2),holes(1).TargetRot(2,2),holes(1).TargetRot(3,2),'g')
        % quiver3(0,0,0,holes(1).TargetRot(1,3),holes(1).TargetRot(2,3),holes(1).TargetRot(3,3),'b')
        % hold off

        %% Time plot
        if (holes(1).StartTime == datetime(0001,01,01,00,00,00))
           first_start = holes(2).StartTime - minutes(10);
        else
            first_start = holes(1).StartTime;
        end


        start1 = 0;
        start2 = 0;
        start3 = 0;
        stop1 = 0;
        stop2 = 0;
        stop3 = 0;

        for i = 1:length(holes)
            switch holes(i).Boom
                case 1
                    if i == 1
                        start1 = 3600*24*datenum(holes(i).StartTime - first_start);
                        stop1 = 3600*24*datenum(holes(i).EndTime - first_start);
                    else
                        start1(end+1) = 3600*24*datenum(holes(i).StartTime - first_start);
                        stop1(end+1) = 3600*24*datenum(holes(i).EndTime - first_start);
                    end
                case 2
                    if i == 1
                        start2 = 3600*24*datenum(holes(i).StartTime - first_start);
                        stop2 = 3600*24*datenum(holes(i).EndTime - first_start);
                    else
                        start2(end+1) = 3600*24*datenum(holes(i).StartTime - first_start);
                        stop2(end+1) = 3600*24*datenum(holes(i).EndTime - first_start);
                    end
                case 3
                    if i == 1
                        start3 = 3600*24*datenum(holes(i).StartTime - first_start);
                        stop3 = 3600*24*datenum(holes(i).EndTime - first_start);
                    else
                        start3(end+1) = 3600*24*datenum(holes(i).StartTime - first_start);
                        stop3(end+1) = 3600*24*datenum(holes(i).EndTime - first_start);
                    end
                otherwise
                    break;
            end
        end
        fig2 = figure('Name',strcat('Gant: ',baseFolderName),'units','normalized','outerposition',[0 0 1 1]);
        subplot(3,1,1)
        barh(stop1, 'LineStyle', 'none');
        hold on
        barh(start1,'w', 'LineStyle', 'none');
        hold off
        title('Boom 1')
        xlim([0 (3600*24*datenum(holes(end).EndTime - first_start)+100)]);
        xticks(0:600:(3600*24*datenum(holes(end).EndTime - first_start)+100));
        grid on

        subplot(3,1,2)
        barh(stop2, 'LineStyle', 'none');
        hold on
        barh(start2,'w', 'LineStyle', 'none');
        hold off
        title('Boom 2')
        xlim([0 (3600*24*datenum(holes(end).EndTime - first_start)+100)]);
        xticks(0:600:(3600*24*datenum(holes(end).EndTime - first_start)+100));
        grid on

        subplot(3,1,3)
        barh(stop3, 'LineStyle', 'none');
        hold on
        barh(start3,'w', 'LineStyle', 'none');
        hold off
        title('Boom 3')
        xlim([0 (3600*24*datenum(holes(end).EndTime - first_start)+100)]);
        xticks(0:600:(3600*24*datenum(holes(end).EndTime - first_start)+100));
        grid on
        saveas(fig2,strcat('C:\Users\eivindjk\Documents\Master\Plots\Gant_',baseFolderName),'fig');
        close(fig2);
        fclose('all');
    end
end

