function hole = readTl4(filename)
    %filename = 'CL_10160 NY_2018_01_11_23_15_215_SingleHole.tl4';

    %% Create hole struct
    field1 = 'HoleType';    value1 = -1;
    field2 = 'Boom';        value2 = -1;
    field3 = 'CoordStart';  value3 = struct('X',-1,'Y',-1,'Z',-1);
    field4 = 'CoordEnd';    value4 = struct('X',-1,'Y',-1,'Z',-1);
    field5 = 'StartTime';   value5 = datetime(0,0,0,0,0,0);
    field6 = 'EndTime';     value6 = datetime(0,0,0,0,0,0);
    field7 = 'HolenoPlan';  value7 = 0;
    %field7 = 'Target';      value7 = struct('X',-1,'Y',-1,'Z',-1);
    %field8 = 'TargetRot';   value8 = [-1,-1,-1;-1,-1,-1;-1,-1,-1];

    hole = struct(field1,value1,field2,value2,field3,value3,field4,value4,field5,value5,field6,value6,field7,value7);
    if (strcmp(filename,'C:\Users\eivindjk\Documents\Master\Hare\1110806\CL_10160 NY\2017-10-30-06-21\CL_10160 NY_2017_10_30_06_21_136_SingleHole.tl4') == false)
        %% Open file
        fileID = fopen(filename);

        C = textscan(fileID,'%s','Delimiter','\n');
        fclose(fileID);
        C = C{1,1};

        %% Read data from [Hole]
        idxHole=ind2sub(size(C), strmatch('[Hole]', C));
        i = idxHole;

        i = i + 1;
        S = sprintf('%s', C{i,1});
        hole.HoleType = sscanf(S, 'HoleType = %d');

        i = i + 1;
        S = sprintf('%s', C{i,1});
        hole.Boom = sscanf(S, 'Boom = %d');

        i = i + 1;
        S = sprintf('%s', C{i,1});
        hole.CoordStart.X = sscanf(S, 'CoordStart.X = %f');

        i = i + 1;
        S = sprintf('%s', C{i,1});
        hole.CoordStart.Y = sscanf(S, 'CoordStart.Y = %f');

        i = i + 1;
        S = sprintf('%s', C{i,1});
        hole.CoordStart.Z = sscanf(S, 'CoordStart.Z = %f');

        i = i + 1;
        S = sprintf('%s', C{i,1});
        hole.CoordEnd.X = sscanf(S, 'CoordEnd.X = %f');

        i = i + 1;
        S = sprintf('%s', C{i,1});
        hole.CoordEnd.Y = sscanf(S, 'CoordEnd.Y = %f');

        i = i + 1;
        S = sprintf('%s', C{i,1});
        hole.CoordEnd.Z = sscanf(S, 'CoordEnd.Z = %f');

        %% Read data from [HoleEx]
        idxHoleEx=ind2sub(size(C), strmatch('[HoleEx]', C));

        S = sprintf('%s', C{idxHoleEx+6,1});
        time = sscanf(S, 'Date started = %d/%d/%d %d:%d:%d');
        hole.StartTime = datetime(time.');

        S = sprintf('%s', C{idxHoleEx+7,1});
        time = sscanf(S, 'Date ended = %d/%d/%d %d:%d:%d');
        hole.EndTime = datetime(time.');
        
        S = sprintf('%s', C{idxHoleEx+2,1});
        hole.HolenoPlan = sscanf(S, 'HolenoPlan = %d');
    %     %% Read data from [RoundEx2]
    %     idxRoundEx2=ind2sub(size(C), strmatch('[RoundEx2]', C));
    %     i = idxRoundEx2;
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.Target.X = sscanf(S, 'Trg.Xp.X = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.Target.Y = sscanf(S, 'Trg.Xp.Y = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.Target.Z = sscanf(S, 'Trg.Xp.Z = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.TargetRot(1,1) = sscanf(S, 'Trg.A.nx.X = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.TargetRot(2,1) = sscanf(S, 'Trg.A.nx.Y = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.TargetRot(3,1) = sscanf(S, 'Trg.A.nx.Z = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.TargetRot(1,2) = sscanf(S, 'Trg.A.ny.X = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.TargetRot(2,2) = sscanf(S, 'Trg.A.ny.Y = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.TargetRot(3,2) = sscanf(S, 'Trg.A.ny.Z = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.TargetRot(1,3) = sscanf(S, 'Trg.A.nz.X = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.TargetRot(2,3) = sscanf(S, 'Trg.A.nz.Y = %f');
    %     
    %     i = i + 1;
    %     S = sprintf('%s', C{i,1});
    %     hole.TargetRot(3,3) = sscanf(S, 'Trg.A.nz.Z = %f');
    end
end