function [sequenceDuration, totalDownTime, boom1DownTime, boom2DownTime, boom3DownTime, endSync, distance] = sequenceScore(holesArray)
    boom1=holesArray(holesArray(:,2)==1,:);
    boom2=holesArray(holesArray(:,2)==2,:);
    boom3=holesArray(holesArray(:,2)==3,:);
    if size(holesArray,1) == 1
        sequenceDuration = holesArray(10);
    else
        maxArray = max(holesArray);
        sequenceDuration = maxArray(10);
    end

    unrelevantDownTime = 0;

    t=1;
    while t <= sequenceDuration
        timeCovered = false;
        for k=1:size(holesArray,1)
            if (holesArray(k,9) <= t && holesArray(k,10) >= t)
                timeCovered = true;
                t = holesArray(k,10);
                break;
            end
        end
        if ~timeCovered
            unrelevantDownTime = unrelevantDownTime + 1;
        end
        t=t+1;
    end

    boom1DrillTime = 0;
    boom2DrillTime = 0;
    boom3DrillTime = 0;
    for i=1:size(boom1,1)
        boom1DrillTime = boom1DrillTime + boom1(i,10)-boom1(i,9);
    end
    for i=1:size(boom2,1)
        boom2DrillTime = boom2DrillTime + boom2(i,10)-boom2(i,9);
    end
    for i=1:size(boom3,1)
        boom3DrillTime = boom3DrillTime + boom3(i,10)-boom3(i,9);
    end

    boom1DownTime = sequenceDuration - boom1DrillTime - unrelevantDownTime;
    boom2DownTime = sequenceDuration - boom2DrillTime - unrelevantDownTime;
    boom3DownTime = sequenceDuration - boom3DrillTime - unrelevantDownTime;
    totalDownTime = boom1DownTime + boom2DownTime + boom3DownTime;
    
    if size(boom1,1) ~= 0
        if size(boom1,1) == 1
            boom1End = boom1(10);
        else
            boom1Max = max(boom1);
            boom1End = boom1Max(10);
        end
    else
        boom1End = 0;
    end
    
    if size(boom2,1) ~= 0
        if size(boom2,1) == 1
            boom2End = boom2(10);
        else
            boom2Max = max(boom2);
            boom2End = boom2Max(10);
        end
    else
        boom2End = 0;
    end
    
    if size(boom3,1) ~= 0
        if size(boom3,1) == 1
            boom3End = boom3(10);
        else
            boom3Max = max(boom3);
            boom3End = boom3Max(10);
        end
    else
        boom3End = 0;
    end
    endSync = max([boom1End boom2End boom3End]) - min([boom1End boom2End boom3End]);
    
    b1=boom1(boom1(:,1)~=4,:);
    b1=b1(b1(:,1)~=5,:);
    b1=b1(b1(:,1)~=6,:);
    
    b2=boom2(boom2(:,1)~=4,:);
    b2=b2(b2(:,1)~=5,:);
    b2=b2(b2(:,1)~=6,:);
    
    b3=boom3(boom3(:,1)~=4,:);
    b3=b3(b3(:,1)~=5,:);
    b3=b3(b3(:,1)~=6,:);
    
    distance = [];
    if size(b1,1) ~= 0
        for i=1:(size(b1,1)-1)
            distance(end+1) = calculateDistanceOne(b1(i,4:5),b1(i+1,4:5));
        end
    end
    if size(b2,1) ~= 0
        for i=1:(size(b2,1)-1)
            distance(end+1) = calculateDistanceOne(b2(i,4:5),b2(i+1,4:5));
        end
    end
    if size(b3,1) ~= 0
        for i=1:(size(b3,1)-1)
            distance(end+1) = calculateDistanceOne(b3(i,4:5),b3(i+1,4:5));
        end
    end
end
