clear;

topDir = 'C:\Users\eivindjk\Documents\Master\Hare\1110806\CL_10160 NY';
topDirFiles = dir(topDir);

dirFlags = [topDirFiles.isdir];
folders = topDirFiles(dirFlags);

firstRun = true;

for j = 1:length(folders)
    baseFolderName = folders(j).name;
    myDir = fullfile(topDir, baseFolderName);
    %myDir = 'C:\Users\eivindjk\Documents\Master\Hare\1110806\CL_10160 NY\2017-10-16-13-18';
    tl4Files = dir(fullfile(myDir,'*SingleHole.tl4'));
    if (isempty(tl4Files))
        
    else
        baseName = tl4Files(1).name;
        fullFileName = fullfile(myDir, baseName);
        fileDir = dir(fullFileName);
        if fileDir.bytes == 0
            
        else
            holes = readTl4(fullFileName);
        end
        for i = 2:length(tl4Files)
            baseName = tl4Files(i).name;
            fullFileName = fullfile(myDir, baseName);
            fileDir = dir(fullFileName);
            if fileDir.bytes == 0
                
            else
                holes(end+1) = readTl4(fullFileName);
            end
        end
        if (length(holes) > 180 && year(holes(1).StartTime) ~= 0001 && year(holes(2).StartTime) ~= 0001)
            sequenceStart = holes(1).StartTime;
            for i=2:length(holes)
               if holes(i).StartTime < sequenceStart
                   sequenceStart = holes(i).StartTime;
               end
            end
            
            holesArray = [];
            holesArray(1,:) = [holes(1).HoleType holes(1).Boom holes(1).CoordStart.X holes(1).CoordStart.Y holes(1).CoordStart.Z holes(1).CoordEnd.X holes(1).CoordEnd.Y holes(1).CoordEnd.Z round(3600*24*datenum(holes(1).StartTime-sequenceStart)) round(3600*24*datenum(holes(1).EndTime-sequenceStart))];
            for i=2:length(holes)
                holesArray(end+1,:) = [holes(i).HoleType holes(i).Boom holes(i).CoordStart.X holes(i).CoordStart.Y holes(i).CoordStart.Z holes(i).CoordEnd.X holes(i).CoordEnd.Y holes(i).CoordEnd.Z round(3600*24*datenum(holes(i).StartTime-sequenceStart)) round(3600*24*datenum(holes(i).EndTime-sequenceStart))];
            end

            holesArray =sortrows(holesArray, 9);

            boom1=holesArray(holesArray(:,2)==1,:);
            boom2=holesArray(holesArray(:,2)==2,:);
            boom3=holesArray(holesArray(:,2)==3,:);

            maxArray = max(holesArray);
            sequenceDuration = maxArray(10);

            unrelevantDownTime = 0;
            
            t=1;
            while t <= sequenceDuration
                timeCovered = false;
                for k=1:size(holesArray,1)
                    if (holesArray(k,9) <= t && holesArray(k,10) >= t)
                        timeCovered = true;
                        t = holesArray(k,10);
                        break;
                    end
                end
                if ~timeCovered
                    unrelevantDownTime = unrelevantDownTime + 1;
                end
                t=t+1;
            end
            
            boom1DrillTime = 0;
            boom2DrillTime = 0;
            boom3DrillTime = 0;
            for i=1:size(boom1,1)
                boom1DrillTime = boom1DrillTime + boom1(i,10)-boom1(i,9);
            end
            for i=1:size(boom2,1)
                boom2DrillTime = boom2DrillTime + boom2(i,10)-boom2(i,9);
            end
            for i=1:size(boom3,1)
                boom3DrillTime = boom3DrillTime + boom3(i,10)-boom3(i,9);
            end

            boom1DownTime = sequenceDuration - boom1DrillTime - unrelevantDownTime;
            boom2DownTime = sequenceDuration - boom2DrillTime - unrelevantDownTime;
            boom3DownTime = sequenceDuration - boom3DrillTime - unrelevantDownTime;
            totalDownTime = boom1DownTime + boom2DownTime + boom3DownTime;

            boom1Max = max(boom1);
            boom1End = boom1Max(10);

            boom2Max = max(boom2);
            boom2End = boom2Max(10);

            boom3Max = max(boom3);
            boom3End = boom3Max(10);

            endSync = max([boom1End boom2End boom3End]) - min([boom1End boom2End boom3End]);

            if firstRun
                score(1,:) = [totalDownTime boom1DownTime boom2DownTime boom3DownTime endSync];
                logID(1,:) = [baseFolderName];
                firstRun = false;
            else
                score(end+1,:) = [totalDownTime boom1DownTime boom2DownTime boom3DownTime endSync];
                logID(end+1,:) = [baseFolderName];
            end
            display(['Score calculated for: ' baseFolderName]);
            
        end
    end
end
