clear;
drillPlan = 'C:\Users\eivindjk\Documents\Bever Team\Favorites\Drillplans\STIGENDE Normalprofil 13960-14410 med 169 ladet hull.xml';
[left,right,center] = allocateHoles(drillPlan);

distanceArray1 = zeros(100,1);
distanceArray2 = zeros(100,1);
distanceArray3 = zeros(100,1);
distanceArrayTot = zeros(100,1);
for i=1:50
    distance = 0;
    minDistance = 0;

    [start1, stop1] = getShortestPathWithoutCollision(center,randi([1 size(center,1)]),randi([1 size(center,1)]),[],[],minDistance);
    distance2 = calculateDistance(start1, stop1);

    [start2, stop2] = getShortestPathWithoutCollision(left,randi([1 size(left,1)]),randi([1 size(left,1)]),start1,[],minDistance);
    distance1 = calculateDistance(start2, stop2);

    [start3, stop3] = getShortestPathWithoutCollision(right,randi([1 size(right,1)]),randi([1 size(right,1)]),start1,start2,minDistance);
    distance3 = calculateDistance(start3, stop3);

    distanceTot = distance1 + distance2 + distance3;
    distanceNormalized = distance/(size(left,1)+size(center,1)+size(right,1));
    distanceArray1(i) = distance1/(size(left,1));
    distanceArray2(i) = distance2/(size(center,1));
    distanceArray3(i) = distance3/(size(right,1));
    distanceArrayTot(i) = distanceNormalized;
end

%%
f = figure;
h = histfit(distanceArray1,10,'kernel');
legend('Data','Probability distribution');
set(f,'Units','Pixels');
set(f, 'OuterPosition', [0, 0, 1500, 1200]);
grid on
title('Distance moved for each hole with random start and end holes','FontSize',72);
xlabel('Distance [m]','FontSize',32);
ylabel('Occurrence','FontSize',32);
set(gca,'FontSize',21)
ax = gca;
outerpos = ax.OuterPosition;
ti = ax.TightInset; 
left = outerpos(1) + ti(1);
bottom = outerpos(2) + ti(2);
ax_width = outerpos(3) - ti(1) - ti(3);
ax_height = outerpos(4) - ti(2) - ti(4);
ax.Position = [left bottom ax_width ax_height];

saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','13960-14410_Drill_distance_random_start_and_end.png'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','13960-14410_Drill_distance_random_start_and_end.fig'));
saveas(f,strcat('C:\Users\eivindjk\Documents\Master\Other plots\','13960-14410_Drill_distance_random_start_and_end.eps'),'epsc');

% saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Allocated_holes.png'));
% saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Allocated_holes.fig'));
% saveas(f1,strcat('C:\Users\eivindjk\Documents\Master\Drill plan plots\','13960-14410_Allocated_holes.eps'),'epsc');